<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="PLC名称" prop="plcName">
        <el-input v-model="queryParams.plcName" placeholder="请输入PLC名称" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="IP地址" prop="ipAddress">
        <el-input v-model="queryParams.ipAddress" placeholder="请输入IP地址" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="通信端口" prop="port">
        <el-input v-model="queryParams.port" placeholder="请输入通信端口" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="状态" prop="status">
        <el-select v-model="queryParams.status" placeholder="角色状态" clearable style="width: 240px">
          <el-option v-for="dict in sys_normal_disable" :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Plus" @click="handleAdd"
          v-hasPermi="['hnyz:plcInfo:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate"
          v-hasPermi="['hnyz:plcInfo:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['hnyz:plcInfo:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport"
          v-hasPermi="['hnyz:plcInfo:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="infoList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <!-- <el-table-column label="主键，自增" align="center" prop="plcId" /> -->
      <el-table-column label="PLC名称" align="center" prop="plcName" />
      <el-table-column label="PLC的IP地址" align="center" prop="ipAddress" />
      <el-table-column label="通信端口" align="center" prop="port" />
      <el-table-column label="采集间隔(ms)" align="center" prop="scanInterval" />
      <el-table-column label="连接超时时间(s)" align="center" prop="connectTimeout" />
      <el-table-column label="状态" align="center" width="100">
        <template #default="scope">
          <el-switch v-model="scope.row.status" active-value="0" inactive-value="1"
            @change="handleStatusChange(scope.row)"></el-switch>
        </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['hnyz:plcInfo:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"
            v-hasPermi="['hnyz:plcInfo:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize" @pagination="getList" />

    <!-- 添加或修改PLC信息管理对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="infoRef" :model="form" :rules="rules" label-width="108px">
        <el-form-item label="PLC名称" prop="plcName">
          <el-input v-model="form.plcName" placeholder="请输入PLC名称" />
        </el-form-item>
        <el-form-item label="PLC的IP地址" prop="ipAddress">
          <el-input v-model="form.ipAddress" placeholder="请输入PLC的IP地址" />
        </el-form-item>
        <el-form-item label="通信端口" prop="port">
          <el-input v-model="form.port" placeholder="请输入通信端口" />
        </el-form-item>
        <el-form-item label="采集间隔" prop="scanInterval">
          <el-input v-model="form.scanInterval" placeholder="请输入采集间隔" />
        </el-form-item>
        <el-form-item label="连接超时时间" prop="connectTimeout">
          <el-input v-model="form.connectTimeout" placeholder="请输入连接超时时间" />
        </el-form-item>
        <el-form-item label="通讯协议" prop="protocolId">
          <el-select v-model="form.protocolId" placeholder="请选择通讯协议">
            <el-option v-for="dict in commProtocolOptions" :key="dict.protocolId" :label="dict.protocolName"
              :value="dict.protocolId"></el-option>
          </el-select>
        </el-form-item>

        <el-form-item label="备注信息" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
        <el-form-item label="启用状态">
          <el-radio-group v-model="form.status">
            <el-radio v-for="dict in sys_normal_disable" :key="dict.value" :value="dict.value">{{ dict.label
            }}</el-radio>
          </el-radio-group>
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Info">
import { onMounted } from "vue";
import { listInfo, getInfo, delInfo, addInfo, updateInfo, changeStatus } from "@/api/hnyz/plcInfo";
import { getCommProtocolList } from "@/api/hnyz/commProtocol";

onMounted(() => {
  getCommProtocolOptions()
});

const { proxy } = getCurrentInstance();
const { sys_normal_disable } = proxy.useDict("sys_normal_disable");

const infoList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    plcName: null,
    port: null,
    status: null,
  },
  rules: {
    plcName: [
      { required: true, message: "PLC名称不能为空", trigger: "blur" }
    ],
    // ipAddress: [
    //   { required: true, message: "PLC的IP地址不能为空", trigger: "blur" }
    // ],
    // port: [
    //   { required: true, message: "通信端口不能为空", trigger: "blur" }
    // ],
    // scanInterval: [
    //   { required: true, message: "采集间隔不能为空", trigger: "blur" }
    // ],
    // connectTimeout: [
    //   { required: true, message: "连接超时时间不能为空", trigger: "blur" }
    // ],
  }
});

const { queryParams, form, rules } = toRefs(data);

const commProtocolOptions = ref([]);// 通讯协议下拉树结构
/** 获取通讯协议列表 */
function getCommProtocolOptions() {
  getCommProtocolList().then(response => {
    commProtocolOptions.value = response.data;
  });
}

/** 查询PLC信息管理列表 */
function getList() {
  loading.value = true;
  listInfo(queryParams.value).then(response => {
    infoList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    plcId: null,
    plcName: null,
    ipAddress: null,
    port: null,
    scanInterval: null,
    connectTimeout: null,
    ipAddress: null,
    port: null,
    protocolId: null,
    status: "0",
    delFlag: null,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null,
    remark: null
  };
  proxy.resetForm("infoRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

/** plc启用状态修改 */
function handleStatusChange(row) {
  let text = row.status == "0" ? "启用" : "停用";
  proxy.$modal.confirm('确认要"' + text + '""' + row.plcName + '"吗?').then(function () {
    return changeStatus(row.plcId, row.status);
  }).then(() => {
    proxy.$modal.msgSuccess(text + "成功");
  }).catch(function () {
    row.status = row.status == "0" ? "1" : "0";
  });
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.plcId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加PLC信息管理";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _plcId = row.plcId || ids.value
  getInfo(_plcId).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = "修改PLC信息管理";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["infoRef"].validate(valid => {
    if (valid) {
      if (form.value.plcId != null) {
        updateInfo(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addInfo(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _plcIds = row.plcId || ids.value;
  proxy.$modal.confirm('是否确认删除PLC信息管理编号为"' + _plcIds + '"的数据项？').then(function () {
    return delInfo(_plcIds);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  }).catch(() => { });
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('hnyz/plcInfo/export', {
    ...queryParams.value
  }, `plcInfo_${new Date().getTime()}.xlsx`)
}

getList();
</script>
